/* .MiK. SoftWare

  Multilingual Terminal Emulator "MTR".

 Copyright (C) 2000 Mike I. Kozin. ALL RIGHT RESERVED
 
 On Base "MuTerminal"
 Copyright (C) 1998,99 Kazuho Okui and Takashi Murai. ALL RIGHT RESERVED
  
 This file is part of MTR.

 MTR is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 PrefHandler.h,v 0.1 26-Sep-2000
***************************************************************************/

#ifndef PREFHANDLER_H_INCLUDED
#define PREFHANDLER_H_INCLUDED

#include <SupportDefs.h>
#include <Errors.h>
#include <GraphicsDefs.h>
#include <Message.h>

struct prefDefaults
{
  const char *key;
  char *item;
};

#define PREF_TRUE "true"
#define PREF_FALSE "false"

class BMessage;
class BEntry;

class PrefHandler{
public:
  PrefHandler();
  PrefHandler(const PrefHandler* p);

  ~PrefHandler();

  status_t    Open(const char *name, const prefDefaults *defaults = NULL);
  status_t    OpenText(const char *path, const prefDefaults *defaults = NULL);
  status_t    Save(const char *name);
  void        SaveAsText(const char *path, const char *minmtype = NULL,
			 const char *signature = NULL);

  int32       getInt32(const char *key);
  float       getFloat(const char *key);
  const char* getString(const char *key);
  bool        getBool(const char *key);
  rgb_color   getRGB(const char *key);

  void        setInt32(const char *key, int32 data);
  void        setFloat(const char *key, float data);
  void        setString(const char *key, const char *data);
  void        setBool(const char *key, bool data);
  void        setRGB(const char *key, const rgb_color data);

  bool        IsEmpty() const;

private:
  status_t    loadFromFile(BEntry *ent);
  status_t    loadFromDefault(const prefDefaults* defaluts = NULL);
  status_t    loadFromTextFile(const char * path);


  BMessage    mPrefContainer;


};

#endif //PREFHANDLER_H_INCLUDED
